/* (c) https://github.com/MontiCore/monticore */
// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: simulationController.proto

package protobuf;

/**
 * Protobuf type {@code SimulationController.GetSimulationResultReply}
 */
public  final class GetSimulationResultReply extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:SimulationController.GetSimulationResultReply)
    GetSimulationResultReplyOrBuilder {
private static final long serialVersionUID = 0L;
  // Use GetSimulationResultReply.newBuilder() to construct.
  private GetSimulationResultReply(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private GetSimulationResultReply() {
    vehicles_ = java.util.Collections.emptyList();
    jsonStr_ = "";
  }

  @java.lang.Override
  public final com.google.protobuf.UnknownFieldSet
  getUnknownFields() {
    return this.unknownFields;
  }
  private GetSimulationResultReply(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    this();
    if (extensionRegistry == null) {
      throw new java.lang.NullPointerException();
    }
    int mutable_bitField0_ = 0;
    com.google.protobuf.UnknownFieldSet.Builder unknownFields =
        com.google.protobuf.UnknownFieldSet.newBuilder();
    try {
      boolean done = false;
      while (!done) {
        int tag = input.readTag();
        switch (tag) {
          case 0:
            done = true;
            break;
          default: {
            if (!parseUnknownFieldProto3(
                input, unknownFields, extensionRegistry, tag)) {
              done = true;
            }
            break;
          }
          case 10: {
            if (!((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
              vehicles_ = new java.util.ArrayList<protobuf.VehicleSimulationDataFrame>();
              mutable_bitField0_ |= 0x00000001;
            }
            vehicles_.add(
                input.readMessage(protobuf.VehicleSimulationDataFrame.parser(), extensionRegistry));
            break;
          }
          case 18: {
            java.lang.String s = input.readStringRequireUtf8();

            jsonStr_ = s;
            break;
          }
        }
      }
    } catch (com.google.protobuf.InvalidProtocolBufferException e) {
      throw e.setUnfinishedMessage(this);
    } catch (java.io.IOException e) {
      throw new com.google.protobuf.InvalidProtocolBufferException(
          e).setUnfinishedMessage(this);
    } finally {
      if (((mutable_bitField0_ & 0x00000001) == 0x00000001)) {
        vehicles_ = java.util.Collections.unmodifiableList(vehicles_);
      }
      this.unknownFields = unknownFields.build();
      makeExtensionsImmutable();
    }
  }
  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_GetSimulationResultReply_descriptor;
  }

  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return protobuf.SimulationControllerProto.internal_static_SimulationController_GetSimulationResultReply_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            protobuf.GetSimulationResultReply.class, protobuf.GetSimulationResultReply.Builder.class);
  }

  private int bitField0_;
  public static final int VEHICLES_FIELD_NUMBER = 1;
  private java.util.List<protobuf.VehicleSimulationDataFrame> vehicles_;
  /**
   * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
   */
  public java.util.List<protobuf.VehicleSimulationDataFrame> getVehiclesList() {
    return vehicles_;
  }
  /**
   * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
   */
  public java.util.List<? extends protobuf.VehicleSimulationDataFrameOrBuilder> 
      getVehiclesOrBuilderList() {
    return vehicles_;
  }
  /**
   * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
   */
  public int getVehiclesCount() {
    return vehicles_.size();
  }
  /**
   * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
   */
  public protobuf.VehicleSimulationDataFrame getVehicles(int index) {
    return vehicles_.get(index);
  }
  /**
   * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
   */
  public protobuf.VehicleSimulationDataFrameOrBuilder getVehiclesOrBuilder(
      int index) {
    return vehicles_.get(index);
  }

  public static final int JSONSTR_FIELD_NUMBER = 2;
  private volatile java.lang.Object jsonStr_;
  /**
   * <code>string jsonStr = 2;</code>
   */
  public java.lang.String getJsonStr() {
    java.lang.Object ref = jsonStr_;
    if (ref instanceof java.lang.String) {
      return (java.lang.String) ref;
    } else {
      com.google.protobuf.ByteString bs = 
          (com.google.protobuf.ByteString) ref;
      java.lang.String s = bs.toStringUtf8();
      jsonStr_ = s;
      return s;
    }
  }
  /**
   * <code>string jsonStr = 2;</code>
   */
  public com.google.protobuf.ByteString
      getJsonStrBytes() {
    java.lang.Object ref = jsonStr_;
    if (ref instanceof java.lang.String) {
      com.google.protobuf.ByteString b = 
          com.google.protobuf.ByteString.copyFromUtf8(
              (java.lang.String) ref);
      jsonStr_ = b;
      return b;
    } else {
      return (com.google.protobuf.ByteString) ref;
    }
  }

  private byte memoizedIsInitialized = -1;
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < vehicles_.size(); i++) {
      output.writeMessage(1, vehicles_.get(i));
    }
    if (!getJsonStrBytes().isEmpty()) {
      com.google.protobuf.GeneratedMessageV3.writeString(output, 2, jsonStr_);
    }
    unknownFields.writeTo(output);
  }

  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < vehicles_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, vehicles_.get(i));
    }
    if (!getJsonStrBytes().isEmpty()) {
      size += com.google.protobuf.GeneratedMessageV3.computeStringSize(2, jsonStr_);
    }
    size += unknownFields.getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof protobuf.GetSimulationResultReply)) {
      return super.equals(obj);
    }
    protobuf.GetSimulationResultReply other = (protobuf.GetSimulationResultReply) obj;

    boolean result = true;
    result = result && getVehiclesList()
        .equals(other.getVehiclesList());
    result = result && getJsonStr()
        .equals(other.getJsonStr());
    result = result && unknownFields.equals(other.unknownFields);
    return result;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getVehiclesCount() > 0) {
      hash = (37 * hash) + VEHICLES_FIELD_NUMBER;
      hash = (53 * hash) + getVehiclesList().hashCode();
    }
    hash = (37 * hash) + JSONSTR_FIELD_NUMBER;
    hash = (53 * hash) + getJsonStr().hashCode();
    hash = (29 * hash) + unknownFields.hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static protobuf.GetSimulationResultReply parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.GetSimulationResultReply parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.GetSimulationResultReply parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.GetSimulationResultReply parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.GetSimulationResultReply parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static protobuf.GetSimulationResultReply parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static protobuf.GetSimulationResultReply parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.GetSimulationResultReply parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.GetSimulationResultReply parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static protobuf.GetSimulationResultReply parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static protobuf.GetSimulationResultReply parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static protobuf.GetSimulationResultReply parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(protobuf.GetSimulationResultReply prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * Protobuf type {@code SimulationController.GetSimulationResultReply}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:SimulationController.GetSimulationResultReply)
      protobuf.GetSimulationResultReplyOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_GetSimulationResultReply_descriptor;
    }

    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_GetSimulationResultReply_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              protobuf.GetSimulationResultReply.class, protobuf.GetSimulationResultReply.Builder.class);
    }

    // Construct using protobuf.GetSimulationResultReply.newBuilder()
    private Builder() {
      maybeForceBuilderInitialization();
    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);
      maybeForceBuilderInitialization();
    }
    private void maybeForceBuilderInitialization() {
      if (com.google.protobuf.GeneratedMessageV3
              .alwaysUseFieldBuilders) {
        getVehiclesFieldBuilder();
      }
    }
    public Builder clear() {
      super.clear();
      if (vehiclesBuilder_ == null) {
        vehicles_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
      } else {
        vehiclesBuilder_.clear();
      }
      jsonStr_ = "";

      return this;
    }

    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return protobuf.SimulationControllerProto.internal_static_SimulationController_GetSimulationResultReply_descriptor;
    }

    public protobuf.GetSimulationResultReply getDefaultInstanceForType() {
      return protobuf.GetSimulationResultReply.getDefaultInstance();
    }

    public protobuf.GetSimulationResultReply build() {
      protobuf.GetSimulationResultReply result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    public protobuf.GetSimulationResultReply buildPartial() {
      protobuf.GetSimulationResultReply result = new protobuf.GetSimulationResultReply(this);
      int from_bitField0_ = bitField0_;
      int to_bitField0_ = 0;
      if (vehiclesBuilder_ == null) {
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          vehicles_ = java.util.Collections.unmodifiableList(vehicles_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.vehicles_ = vehicles_;
      } else {
        result.vehicles_ = vehiclesBuilder_.build();
      }
      result.jsonStr_ = jsonStr_;
      result.bitField0_ = to_bitField0_;
      onBuilt();
      return result;
    }

    public Builder clone() {
      return (Builder) super.clone();
    }
    public Builder setField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.setField(field, value);
    }
    public Builder clearField(
        com.google.protobuf.Descriptors.FieldDescriptor field) {
      return (Builder) super.clearField(field);
    }
    public Builder clearOneof(
        com.google.protobuf.Descriptors.OneofDescriptor oneof) {
      return (Builder) super.clearOneof(oneof);
    }
    public Builder setRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        int index, java.lang.Object value) {
      return (Builder) super.setRepeatedField(field, index, value);
    }
    public Builder addRepeatedField(
        com.google.protobuf.Descriptors.FieldDescriptor field,
        java.lang.Object value) {
      return (Builder) super.addRepeatedField(field, value);
    }
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof protobuf.GetSimulationResultReply) {
        return mergeFrom((protobuf.GetSimulationResultReply)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(protobuf.GetSimulationResultReply other) {
      if (other == protobuf.GetSimulationResultReply.getDefaultInstance()) return this;
      if (vehiclesBuilder_ == null) {
        if (!other.vehicles_.isEmpty()) {
          if (vehicles_.isEmpty()) {
            vehicles_ = other.vehicles_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureVehiclesIsMutable();
            vehicles_.addAll(other.vehicles_);
          }
          onChanged();
        }
      } else {
        if (!other.vehicles_.isEmpty()) {
          if (vehiclesBuilder_.isEmpty()) {
            vehiclesBuilder_.dispose();
            vehiclesBuilder_ = null;
            vehicles_ = other.vehicles_;
            bitField0_ = (bitField0_ & ~0x00000001);
            vehiclesBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getVehiclesFieldBuilder() : null;
          } else {
            vehiclesBuilder_.addAllMessages(other.vehicles_);
          }
        }
      }
      if (!other.getJsonStr().isEmpty()) {
        jsonStr_ = other.jsonStr_;
        onChanged();
      }
      this.mergeUnknownFields(other.unknownFields);
      onChanged();
      return this;
    }

    public final boolean isInitialized() {
      return true;
    }

    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      protobuf.GetSimulationResultReply parsedMessage = null;
      try {
        parsedMessage = PARSER.parsePartialFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        parsedMessage = (protobuf.GetSimulationResultReply) e.getUnfinishedMessage();
        throw e.unwrapIOException();
      } finally {
        if (parsedMessage != null) {
          mergeFrom(parsedMessage);
        }
      }
      return this;
    }
    private int bitField0_;

    private java.util.List<protobuf.VehicleSimulationDataFrame> vehicles_ =
      java.util.Collections.emptyList();
    private void ensureVehiclesIsMutable() {
      if (!((bitField0_ & 0x00000001) == 0x00000001)) {
        vehicles_ = new java.util.ArrayList<protobuf.VehicleSimulationDataFrame>(vehicles_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.VehicleSimulationDataFrame, protobuf.VehicleSimulationDataFrame.Builder, protobuf.VehicleSimulationDataFrameOrBuilder> vehiclesBuilder_;

    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public java.util.List<protobuf.VehicleSimulationDataFrame> getVehiclesList() {
      if (vehiclesBuilder_ == null) {
        return java.util.Collections.unmodifiableList(vehicles_);
      } else {
        return vehiclesBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public int getVehiclesCount() {
      if (vehiclesBuilder_ == null) {
        return vehicles_.size();
      } else {
        return vehiclesBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public protobuf.VehicleSimulationDataFrame getVehicles(int index) {
      if (vehiclesBuilder_ == null) {
        return vehicles_.get(index);
      } else {
        return vehiclesBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder setVehicles(
        int index, protobuf.VehicleSimulationDataFrame value) {
      if (vehiclesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureVehiclesIsMutable();
        vehicles_.set(index, value);
        onChanged();
      } else {
        vehiclesBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder setVehicles(
        int index, protobuf.VehicleSimulationDataFrame.Builder builderForValue) {
      if (vehiclesBuilder_ == null) {
        ensureVehiclesIsMutable();
        vehicles_.set(index, builderForValue.build());
        onChanged();
      } else {
        vehiclesBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder addVehicles(protobuf.VehicleSimulationDataFrame value) {
      if (vehiclesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureVehiclesIsMutable();
        vehicles_.add(value);
        onChanged();
      } else {
        vehiclesBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder addVehicles(
        int index, protobuf.VehicleSimulationDataFrame value) {
      if (vehiclesBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureVehiclesIsMutable();
        vehicles_.add(index, value);
        onChanged();
      } else {
        vehiclesBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder addVehicles(
        protobuf.VehicleSimulationDataFrame.Builder builderForValue) {
      if (vehiclesBuilder_ == null) {
        ensureVehiclesIsMutable();
        vehicles_.add(builderForValue.build());
        onChanged();
      } else {
        vehiclesBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder addVehicles(
        int index, protobuf.VehicleSimulationDataFrame.Builder builderForValue) {
      if (vehiclesBuilder_ == null) {
        ensureVehiclesIsMutable();
        vehicles_.add(index, builderForValue.build());
        onChanged();
      } else {
        vehiclesBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder addAllVehicles(
        java.lang.Iterable<? extends protobuf.VehicleSimulationDataFrame> values) {
      if (vehiclesBuilder_ == null) {
        ensureVehiclesIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, vehicles_);
        onChanged();
      } else {
        vehiclesBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder clearVehicles() {
      if (vehiclesBuilder_ == null) {
        vehicles_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        vehiclesBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public Builder removeVehicles(int index) {
      if (vehiclesBuilder_ == null) {
        ensureVehiclesIsMutable();
        vehicles_.remove(index);
        onChanged();
      } else {
        vehiclesBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public protobuf.VehicleSimulationDataFrame.Builder getVehiclesBuilder(
        int index) {
      return getVehiclesFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public protobuf.VehicleSimulationDataFrameOrBuilder getVehiclesOrBuilder(
        int index) {
      if (vehiclesBuilder_ == null) {
        return vehicles_.get(index);  } else {
        return vehiclesBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public java.util.List<? extends protobuf.VehicleSimulationDataFrameOrBuilder> 
         getVehiclesOrBuilderList() {
      if (vehiclesBuilder_ != null) {
        return vehiclesBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(vehicles_);
      }
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public protobuf.VehicleSimulationDataFrame.Builder addVehiclesBuilder() {
      return getVehiclesFieldBuilder().addBuilder(
          protobuf.VehicleSimulationDataFrame.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public protobuf.VehicleSimulationDataFrame.Builder addVehiclesBuilder(
        int index) {
      return getVehiclesFieldBuilder().addBuilder(
          index, protobuf.VehicleSimulationDataFrame.getDefaultInstance());
    }
    /**
     * <code>repeated .SimulationController.VehicleSimulationDataFrame vehicles = 1;</code>
     */
    public java.util.List<protobuf.VehicleSimulationDataFrame.Builder> 
         getVehiclesBuilderList() {
      return getVehiclesFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        protobuf.VehicleSimulationDataFrame, protobuf.VehicleSimulationDataFrame.Builder, protobuf.VehicleSimulationDataFrameOrBuilder> 
        getVehiclesFieldBuilder() {
      if (vehiclesBuilder_ == null) {
        vehiclesBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            protobuf.VehicleSimulationDataFrame, protobuf.VehicleSimulationDataFrame.Builder, protobuf.VehicleSimulationDataFrameOrBuilder>(
                vehicles_,
                ((bitField0_ & 0x00000001) == 0x00000001),
                getParentForChildren(),
                isClean());
        vehicles_ = null;
      }
      return vehiclesBuilder_;
    }

    private java.lang.Object jsonStr_ = "";
    /**
     * <code>string jsonStr = 2;</code>
     */
    public java.lang.String getJsonStr() {
      java.lang.Object ref = jsonStr_;
      if (!(ref instanceof java.lang.String)) {
        com.google.protobuf.ByteString bs =
            (com.google.protobuf.ByteString) ref;
        java.lang.String s = bs.toStringUtf8();
        jsonStr_ = s;
        return s;
      } else {
        return (java.lang.String) ref;
      }
    }
    /**
     * <code>string jsonStr = 2;</code>
     */
    public com.google.protobuf.ByteString
        getJsonStrBytes() {
      java.lang.Object ref = jsonStr_;
      if (ref instanceof String) {
        com.google.protobuf.ByteString b = 
            com.google.protobuf.ByteString.copyFromUtf8(
                (java.lang.String) ref);
        jsonStr_ = b;
        return b;
      } else {
        return (com.google.protobuf.ByteString) ref;
      }
    }
    /**
     * <code>string jsonStr = 2;</code>
     */
    public Builder setJsonStr(
        java.lang.String value) {
      if (value == null) {
    throw new NullPointerException();
  }
  
      jsonStr_ = value;
      onChanged();
      return this;
    }
    /**
     * <code>string jsonStr = 2;</code>
     */
    public Builder clearJsonStr() {
      
      jsonStr_ = getDefaultInstance().getJsonStr();
      onChanged();
      return this;
    }
    /**
     * <code>string jsonStr = 2;</code>
     */
    public Builder setJsonStrBytes(
        com.google.protobuf.ByteString value) {
      if (value == null) {
    throw new NullPointerException();
  }
  checkByteStringIsUtf8(value);
      
      jsonStr_ = value;
      onChanged();
      return this;
    }
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFieldsProto3(unknownFields);
    }

    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:SimulationController.GetSimulationResultReply)
  }

  // @@protoc_insertion_point(class_scope:SimulationController.GetSimulationResultReply)
  private static final protobuf.GetSimulationResultReply DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new protobuf.GetSimulationResultReply();
  }

  public static protobuf.GetSimulationResultReply getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<GetSimulationResultReply>
      PARSER = new com.google.protobuf.AbstractParser<GetSimulationResultReply>() {
    public GetSimulationResultReply parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return new GetSimulationResultReply(input, extensionRegistry);
    }
  };

  public static com.google.protobuf.Parser<GetSimulationResultReply> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<GetSimulationResultReply> getParserForType() {
    return PARSER;
  }

  public protobuf.GetSimulationResultReply getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

